Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/InputAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -46,16 +46,16 @@
   FormatParserStorage &parsers = FormatParserStorage::getInstance();
 
-  LOG(0, "Config file given " << params.filename << ".");
+  LOG(0, "Config file given " << params.filename.get() << ".");
   // using the filename as prefix for all parsers
   std::string FilenameSuffix;
   std::string FilenamePrefix;
-  if (params.filename.has_filename()) {
+  if (params.filename.get().has_filename()) {
     // get suffix
 #if BOOST_VERSION >= 104600
-    FilenameSuffix = params.filename.extension().string().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.stem().string();
+    FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
+    FilenamePrefix = params.filename.get().stem().string();
 #else
-    FilenameSuffix = params.filename.extension().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.stem();
+    FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
+    FilenamePrefix = params.filename.get().stem();
 #endif
     LOG(1, "Setting config file name prefix to " << FilenamePrefix << ".");
@@ -67,6 +67,6 @@
 
   // parsing file if present
-  if (!boost::filesystem::exists(params.filename)) {
-    LOG(1, "Specified config file " << params.filename << " not found.");
+  if (!boost::filesystem::exists(params.filename.get())) {
+    LOG(1, "Specified config file " << params.filename.get() << " not found.");
     // DONT FAIL: it's just empty and we use the name. // return Action::failure;
     // nonetheless, add to output formats
@@ -76,5 +76,5 @@
 
     // parse the file
-    test.open(params.filename);
+    test.open(params.filename.get());
     parsers.load(test, FilenameSuffix);
     parsers.setOutputFormat( parsers.getTypeFromSuffix(FilenameSuffix) );
Index: src/Actions/WorldAction/InputAction.def
===================================================================
--- src/Actions/WorldAction/InputAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/InputAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 #include <boost/filesystem.hpp>
 
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)
 #define paramtokens ("input")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (filename)
+#define paramvalids \
+(ParserFileValidator())
 
 #undef statetypes
Index: src/Actions/WorldAction/OutputAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/OutputAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -39,17 +39,17 @@
 /** =========== define the function ====================== */
 Action::state_ptr WorldOutputAction::performCall() {
-  LOG(1, "Storing world to file " << params.filename << ".");
+  LOG(1, "Storing world to file " << params.filename.get() << ".");
 
   // extract suffix
   std::string FilenameSuffix;
   std::string FilenamePrefix;
-  if (params.filename.has_filename()) {
+  if (params.filename.get().has_filename()) {
     // get suffix
 #if BOOST_VERSION >= 104600
-    FilenameSuffix = params.filename.extension().string().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.stem().string();
+    FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
+    FilenamePrefix = params.filename.get().stem().string();
 #else
-    FilenameSuffix = params.filename.extension().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.stem();
+    FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
+    FilenamePrefix = params.filename.get().stem();
 #endif
   } else {
@@ -61,9 +61,9 @@
   // parse the file
   boost::filesystem::ofstream output;
-  output.open(params.filename);
+  output.open(params.filename.get());
   if (!output.fail()) {
     FormatParserStorage::getInstance().saveWorld(output, FilenameSuffix);
   } else {
-    ELOG(1, "Could not open file " << params.filename << ".");
+    ELOG(1, "Could not open file " << params.filename.get() << ".");
   }
   output.close();
Index: src/Actions/WorldAction/OutputAction.def
===================================================================
--- src/Actions/WorldAction/OutputAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/OutputAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,11 @@
 #
 
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)
 #define paramtokens ("output")
@@ -17,4 +21,6 @@
 #undef paramdefaults
 #define paramreferences (filename)
+#define paramvalids \
+(!FilePresentValidator() && ParserFileValidator())
 
 #undef statetypes
Index: src/Actions/WorldAction/RepeatBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/RepeatBoxAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -45,5 +45,7 @@
 /** =========== define the function ====================== */
 
-void repeatMoleculesinDomain(Vector Repeater, const std::vector<molecule *> &AllMolecules)
+void repeatMoleculesinDomain(
+    std::vector< unsigned int > Repeater,
+    const std::vector<molecule *> &AllMolecules)
 {
   LOG(0, "STATUS: Repeating box " << Repeater << " times for (x,y,z) axis.");
@@ -53,7 +55,7 @@
   RealSpaceMatrix newM = M;
   Vector x,y;
-  int n[NDIM];
+  unsigned int n[NDIM];
   RealSpaceMatrix repMat;
-  for (int axis = 0; axis < NDIM; axis++) {
+  for (unsigned int axis = 0; axis < NDIM; axis++) {
     Repeater[axis] = floor(Repeater[axis]);
     if (Repeater[axis] < 1) {
@@ -109,5 +111,5 @@
   WorldRepeatBoxState *undostate = new WorldRepeatBoxState(olddomain, oldmolecules, params);
 
-  repeatMoleculesinDomain(params.Repeater, AllMolecules);
+  repeatMoleculesinDomain(params.Repeater.get(), AllMolecules);
 
   // give final box size
@@ -151,5 +153,5 @@
       ++iter)
     originalmolecules.push_back(*iter);
-  repeatMoleculesinDomain(state->params.Repeater, originalmolecules);
+  repeatMoleculesinDomain(state->params.Repeater.get(), originalmolecules);
 
   // give final box size
Index: src/Actions/WorldAction/RepeatBoxAction.def
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/RepeatBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,19 +7,24 @@
 
 // all includes and forward declarations necessary for non-integral types below
-#include "Actions/Values.hpp"
 #include "LinearAlgebra/RealSpaceMatrix.hpp"
-#include "LinearAlgebra/Vector.hpp"
 #include <set>
+#include <vector>
 
 class molecule;
 
+#include "LinearAlgebra/defs.hpp"
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (Vector)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::vector< unsigned int >)
 #define paramtokens ("repeat-box")
 #define paramdescriptions ("number of copies to create per axis")
 #undef paramdefaults
 #define paramreferences (Repeater)
+#define paramvalids \
+(STLVectorValidator< std::vector< unsigned int > >(NDIM, NDIM))
 
 #define statetypes (RealSpaceMatrix)(std::set< molecule *>)
Index: src/Actions/WorldAction/ScaleBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/ScaleBoxAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,5 +44,5 @@
   // scale atoms
   for (int i=0;i<NDIM;i++)
-    x[i] = params.Scaler[i];
+    x[i] = params.Scaler.get()[i];
   std::vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
   for(std::vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
@@ -54,5 +54,5 @@
   RealSpaceMatrix scale;
   for (int i=0;i<NDIM;i++) {
-    scale.at(i,i) = params.Scaler[i];
+    scale.at(i,i) = params.Scaler.get()[i];
   }
   M *= scale;
@@ -74,5 +74,5 @@
   double x[NDIM];
   for (int i=0;i<NDIM;i++)
-    x[i] = 1./state->params.Scaler[i];
+    x[i] = 1./state->params.Scaler.get()[i];
   vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
   for(vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
@@ -84,5 +84,5 @@
   RealSpaceMatrix scale;
   for (int i=0;i<NDIM;i++) {
-    scale.at(i,i) = 1./state->params.Scaler[i];
+    scale.at(i,i) = 1./state->params.Scaler.get()[i];
   }
   M *= scale;
@@ -101,5 +101,5 @@
   double x[NDIM];
   for (int i=0;i<NDIM;i++)
-    x[i] = state->params.Scaler[i];
+    x[i] = state->params.Scaler.get()[i];
   vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
   for(vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
@@ -111,5 +111,5 @@
   RealSpaceMatrix scale;
   for (int i=0;i<NDIM;i++) {
-    scale.at(i,i) = state->params.Scaler[i];
+    scale.at(i,i) = state->params.Scaler.get()[i];
   }
   M *= scale;
Index: src/Actions/WorldAction/ScaleBoxAction.def
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/ScaleBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,9 @@
 #include "LinearAlgebra/Vector.hpp"
 
+#include "Parameters/Validators/Specific/VectorPositiveComponentsValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (Vector)
 #define paramtokens ("scale-box")
@@ -18,4 +20,6 @@
 #undef paramdefaults
 #define paramreferences (Scaler)
+#define paramvalids \
+(VectorPositiveComponentsValidator())
 
 #undef statetypes
Index: src/Actions/WorldAction/SetBoundaryConditionsAction.cpp
===================================================================
--- src/Actions/WorldAction/SetBoundaryConditionsAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetBoundaryConditionsAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -52,5 +52,5 @@
 
   // set conditions
-  World::getInstance().getDomain().setConditions(params.newconditions);
+  World::getInstance().getDomain().setConditions(params.newconditions.get());
 
   LOG(0, "STATUS: Boundary conditions are now " << World::getInstance().getDomain().getConditionNames() << ".");
@@ -72,5 +72,5 @@
 
   // set again conditions
-  World::getInstance().getDomain().setConditions(state->params.newconditions);
+  World::getInstance().getDomain().setConditions(state->params.newconditions.get());
 
   LOG(0, "STATUS: Boundary conditions are again " << World::getInstance().getDomain().getConditionNames() << ".");
Index: src/Actions/WorldAction/SetBoundaryConditionsAction.def
===================================================================
--- src/Actions/WorldAction/SetBoundaryConditionsAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetBoundaryConditionsAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,12 +10,17 @@
 #include <string>
 
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/BoundaryConditionValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (std::vector< std::string >)
 #define paramtokens ("set-boundary-conditions")
 #define paramdescriptions ("new boundary conditions as list of three strings, e.g. 'wrap wrap ignore'")
 #undef paramdefaults
 #define paramreferences (newconditions)
+#define paramvalids \
+(STLVectorValidator< std::vector< std::string > >(NDIM, NDIM, BoundaryConditionValidator()))
 
 #define statetypes (std::string)
Index: src/Actions/WorldAction/SetDefaultNameAction.cpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,5 +40,5 @@
   WorldSetDefaultNameState *UndoState = new WorldSetDefaultNameState(Worldsdefaultname, params);
 
-  World::getInstance().setDefaultName(params.newname);
+  World::getInstance().setDefaultName(params.newname.get());
   LOG(0, "Default name of new molecules set to " << World::getInstance().getDefaultName() << ".");
   return Action::state_ptr(UndoState);
@@ -57,5 +57,5 @@
   WorldSetDefaultNameState *state = assert_cast<WorldSetDefaultNameState*>(_state.get());
 
-  World::getInstance().setDefaultName(state->params.newname);
+  World::getInstance().setDefaultName(state->params.newname.get());
   LOG(0, "Default name of new molecules set to " << World::getInstance().getDefaultName() << ".");
 
Index: src/Actions/WorldAction/SetDefaultNameAction.def
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetDefaultNameAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("default-molname")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (newname)
+#define paramvalids \
+(DummyValidator< std::string >())
 
 #define statetypes (std::string)
Index: src/Actions/WorldAction/SetWorldTimeAction.cpp
===================================================================
--- src/Actions/WorldAction/SetWorldTimeAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetWorldTimeAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -41,5 +41,5 @@
   WorldSetWorldTimeState *UndoState = new WorldSetWorldTimeState(oldtime, params);
 
-  WorldTime::getInstance().setTime(params.newtime);
+  WorldTime::getInstance().setTime(params.newtime.get());
   LOG(0, "Current time step is now: " << WorldTime::getTime() << ".");
   return Action::state_ptr(UndoState);
@@ -58,5 +58,5 @@
   WorldSetWorldTimeState *state = assert_cast<WorldSetWorldTimeState*>(_state.get());
 
-  WorldTime::getInstance().setTime(state->params.newtime);
+  WorldTime::getInstance().setTime(state->params.newtime.get());
   LOG(0, "Current time step is now: " << WorldTime::getTime() << ".");
 
Index: src/Actions/WorldAction/SetWorldTimeAction.def
===================================================================
--- src/Actions/WorldAction/SetWorldTimeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/SetWorldTimeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,14 +9,18 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (int)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (unsigned int)
 #define paramtokens ("set-world-time")
 #define paramdescriptions ("new time step")
-#define paramdefaults ("0")
+#define paramdefaults (PARAM_DEFAULT(0))
 #define paramreferences (newtime)
+#define paramvalids \
+(DummyValidator< unsigned int >())
 
-#define statetypes (int)
+#define statetypes (unsigned int)
 #define statereferences (oldtime)
 
Index: src/Actions/test.sh
===================================================================
--- src/Actions/test.sh	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/Actions/test.sh	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,19 @@
+#!/bin/bash
+
+OLDIFS=$IFS
+IFS='
+'
+# add paramvalids line
+for file in `find . -name '*.def' -exec grep -H "#define paramtypes" {} \;`; do 
+	paramfile=`echo $file | awk -F":" {'print $1'}`
+	validline=`echo $file | sed -e "s/[^:]*://" -e "s/(\([^)]*\))/(DummyValidator< \1 >())/g" -e "s/paramtypes/paramvalids/"`
+	if [ ! -z `grep "^#define paramtypes" $paramfile` ]; then
+		echo -n "$paramfile :"
+		sed -i -e "s/^\(#define paramtypes.*\)/\1\n$validline/" $paramfile 
+#| grep --after-context=1 "#define paramdefaults"
+	fi
+done
+IFS=$OLDIFS
+
+# append include
+find . -name '*.def' -exec sed -i -e "s#\(// i.e. there is an integer with variable name Z that can be found in\)#\#include \"Parameters/Validators/DummyValidator.hpp\"\n\n\1#" {} \;
Index: src/Actions/unittests/Makefile.am
===================================================================
--- src/Actions/unittests/Makefile.am	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/unittests/Makefile.am	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,5 +31,9 @@
 ActionRegistryUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
 	../Actions/unittests/ActionRegistryUnitTest.cpp \
-	../Actions/unittests/ActionRegistryUnitTest.hpp
+	../Actions/unittests/ActionRegistryUnitTest.hpp \
+	../Parameters/unittests/stubs/ActionNameValidatorStub.cpp \
+	../Parameters/unittests/stubs/BoxLengthValidatorStub.cpp \
+	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp \
+	../Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp
 ActionRegistryUnitTest_LDADD = ${ACTIONLIBS}
 
@@ -37,5 +41,9 @@
 	../Actions/unittests/ActionSequenceUnitTest.cpp \
 	../Actions/unittests/ActionSequenceUnitTest.hpp \
-	../Actions/unittests/stubs/DummyUI.hpp
+	../Actions/unittests/stubs/DummyUI.hpp \
+	../Parameters/unittests/stubs/ActionNameValidatorStub.cpp \
+	../Parameters/unittests/stubs/BoxLengthValidatorStub.cpp \
+	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp \
+	../Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp
 ActionSequenceUnitTest_LDADD = \
 	${ACTIONLIBS} \
Index: src/Actions/unittests/stubs/DummyUI.hpp
===================================================================
--- src/Actions/unittests/stubs/DummyUI.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/unittests/stubs/DummyUI.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -14,4 +14,5 @@
 #endif
 
+#include "Parameters/Parameter.hpp"
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
@@ -24,25 +25,25 @@
 
   virtual void queryEmpty(const char *, std::string = ""){}
-  virtual void queryBoolean(const char *, std::string = ""){}
-  virtual void queryInt(const char *, std::string = ""){}
-  virtual void queryInts(const char *, std::string = ""){}
-  virtual void queryUnsignedInt(const char *, std::string = ""){}
-  virtual void queryUnsignedInts(const char *, std::string = ""){}
-  virtual void queryString(const char*, std::string = ""){}
-  virtual void queryStrings(const char*, std::string = ""){}
-  virtual void queryDouble(const char*, std::string = ""){}
-  virtual void queryDoubles(const char*, std::string = ""){}
-  virtual void queryAtom(const char*,std::string = ""){}
-  virtual void queryAtoms(const char*,std::string = ""){}
-  virtual void queryMolecule(const char*,std::string = ""){}
-  virtual void queryMolecules(const char*,std::string = ""){}
-  virtual void queryVector(const char*,bool, std::string = ""){}
-  virtual void queryVectors(const char*,bool, std::string = ""){}
-  virtual void queryBox(const char*, std::string = ""){}
-  virtual void queryElement(const char*, std::string = ""){}
-  virtual void queryElements(const char*, std::string = ""){}
-  virtual void queryFile(const char*, std::string = ""){}
-  virtual void queryFiles(const char*, std::string = ""){}
-  virtual void queryRandomNumberDistribution_Parameters(const char*, std::string = ""){}
+  virtual void queryBoolean(Parameter<bool> &, const char *, std::string = ""){}
+  virtual void queryInt(Parameter<int> &, const char *, std::string = ""){}
+  virtual void queryInts(Parameter<std::vector<int> > &, const char *, std::string = ""){}
+  virtual void queryUnsignedInt(Parameter<unsigned int> &, const char *, std::string = ""){}
+  virtual void queryUnsignedInts(Parameter<std::vector<unsigned int> > &, const char *, std::string = ""){}
+  virtual void queryString(Parameter<std::string> &, const char*, std::string = ""){}
+  virtual void queryStrings(Parameter<std::vector<std::string> > &, const char*, std::string = ""){}
+  virtual void queryDouble(Parameter<double> &, const char*, std::string = ""){}
+  virtual void queryDoubles(Parameter<std::vector<double> > &, const char*, std::string = ""){}
+  virtual void queryAtom(Parameter<const atom *> &, const char*,std::string = ""){}
+  virtual void queryAtoms(Parameter<std::vector<const atom *> > &, const char*,std::string = ""){}
+  virtual void queryMolecule(Parameter<const molecule *> &, const char*,std::string = ""){}
+  virtual void queryMolecules(Parameter<std::vector<const molecule *> > &, const char*,std::string = ""){}
+  virtual void queryVector(Parameter<Vector> &, const char*,bool, std::string = ""){}
+  virtual void queryVectors(Parameter<std::vector<Vector> > &, const char*,bool, std::string = ""){}
+  virtual void queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &, const char*, std::string = ""){}
+  virtual void queryElement(Parameter<const element *> &, const char*, std::string = ""){}
+  virtual void queryElements(Parameter<std::vector<const element *> > &, const char*, std::string = ""){}
+  virtual void queryFile(Parameter<boost::filesystem::path> &, const char*, std::string = ""){}
+  virtual void queryFiles(Parameter<std::vector< boost::filesystem::path> >&, const char*, std::string = ""){}
+  virtual void queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &, const char*, std::string = ""){}
 };
 
